// Star-Wars Cellular Automata //


#include <string.h>
#include <3ds.h>


#define WIDTH  400
#define HEIGHT 240
#define SCREEN 400*240


	int current [WIDTH][HEIGHT];
	int next [WIDTH][HEIGHT];
	int alive_counts [WIDTH][HEIGHT];
	int tmp[WIDTH][HEIGHT];
  
	int ALIVE = 3;
	int DEATH_1 = 2;
	int DEAD = 0;


	int x,y,nx,ny;

	int col;



int main() {


	// Initialize services

	srvInit();
	aptInit();
	hidInit(NULL);
	gfxInit();

	//gfxSet3D(true); // uncomment if using stereoscopic 3D

	

	for (x = 0; x < WIDTH; x++) {
	
		for (y = 0; y < HEIGHT; y++) {
		
			current[x][y] = rand() % 5;
			alive_counts[x][y] = 0;
			
		}
    	}



	// Main loop

		while (aptMainLoop()) {


			gspWaitForVBlank();

			hidScanInput();


			u32 kDown = hidKeysDown();

			if (kDown & KEY_START) break;


			u8* fb = gfxGetFramebuffer(GFX_TOP, GFX_LEFT, NULL, NULL);


			step();

			
			memset(fb, 0, SCREEN * 3);

			
			draw_type(50,100, 100,100,100, 155);
			draw_type(2,49, 255,255,50, 100);
			draw_type(0,1, 100,100,255, 255);


			gfxFlushBuffers();

			gfxSwapBuffers();


		}

	// Exit services

	gfxExit();
	hidExit();
	aptExit();
	srvExit();

	return 0;

}

  
 void step() {
 
    for (x = 0; x < WIDTH; x++) {
	
		for (y = 0; y < HEIGHT; y++) {
		
		int count = 0;
		int next_val;
    
		int mx = WIDTH-1;
		int my = HEIGHT-1;
		
        int self = current[x][y];
    
    for (nx = x-1; nx <= x+1; nx++) {
	
		for (ny = y-1; ny <= y+1; ny++) {
		
			if (nx == x && ny == y) continue;
			
			if (current[wrap(nx, mx)][wrap(ny, my)] == ALIVE) count++;
			
		}   
    }  

    int neighbors = count;
    
    if (self == ALIVE) next_val = ((neighbors == 3) || (neighbors == 4) || (neighbors == 5)) ? ALIVE : DEATH_1;
	
		else if (self == DEAD) next_val = (neighbors == 2) ? ALIVE : DEAD;
	
		else next_val = self-1;
   
    next[x][y] = next_val;
	
        if (next_val == ALIVE) {
		
			if ((alive_counts[x][y]+1) <= 100) alive_counts[x][y] = (int)(alive_counts[x][y]+1);
        
			} else if (next_val == DEAD) alive_counts[x][y] = 0;
		}
    }
    
    for (x = 0; x < WIDTH; x++) {
	
		for (y = 0; y < HEIGHT; y++) {
        
			tmp[x][y] = current[x][y];
			current[x][y] = next[x][y];
			next[x][y] = tmp[x][y];
    
		}
    }
	
  }
  

  
int wrap(int v, int m) {

    if (v < 0) return v + m;

		else if (v >= m) return v - m;

		else return v;
  }
  
  
void draw_type(int min_alive, int max_alive, int r, int g, int b, int s) {  
    
    for (x = 0; x < WIDTH; x++) {
	
      
		for (y = 0; y < HEIGHT; y++) {
		
			int self = current[x][y];
				
				if (self == DEAD) continue;
        
        int alive = alive_counts[x][y];
		
        if (alive < min_alive || alive > max_alive) continue;
		
		u8* fb = gfxGetFramebuffer(GFX_TOP, GFX_LEFT, NULL, NULL);

		fb[3*((y)+(x)*240)]   = s;
		fb[3*((y)+(x)*240)+1] = s<<1;
		fb[3*((y)+(x)*240)+2] = s<<2;
        
		}
    }
 
  }

